#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-
#
# License: GNU General Public License v2
#
# Author: thl-cmk[at]outlook[dot]com
# URL   : https://thl-cmk.hopto.org
# Date  : 2019-08-19
#
# Check Point Policy Server connections metrics plugins
# checkpoint_remoteaccess
#

##############################################################################
#
# define units for perfdata
#
##############################################################################

##############################################################################
#
# define metrics for perfdata
#
##############################################################################

metric_info['checkpoint_remoteaccess_dtpsConnectedUsers'] = {
    'title': _('DTPS Connected users'),
    'unit': 'count',
    'color': '11/a',
}

metric_info['checkpoint_remoteaccess_raUsers'] = {
    'title': _('RA Connected users'),
    'unit': 'count',
    'color': '12/a',
}

metric_info['checkpoint_remoteaccess_raUsersActive'] = {
    'title': _('RA users active'),
    'unit': 'count',
    'color': '13/a',
}
metric_info['checkpoint_remoteaccess_raUsersDestroy'] = {
    'title': _('RA users destroy'),
    'unit': 'count',
    'color': '14/a',
}
metric_info['checkpoint_remoteaccess_raUsersIdle'] = {
    'title': _('RA users idle'),
    'unit': 'count',
    'color': '15/a',
}
metric_info['checkpoint_remoteaccess_raUsersPhase1'] = {
    'title': _('RA users phase1'),
    'unit': 'count',
    'color': '16/a',
}
metric_info['checkpoint_remoteaccess_raUsersDown'] = {
    'title': _('RA users down'),
    'unit': 'count',
    'color': '21/a',
}
metric_info['checkpoint_remoteaccess_raUsersInit'] = {
    'title': _('RA users init'),
    'unit': 'count',
    'color': '22/a',
}

metric_info['checkpoint_remoteaccess_raBadEncryption'] = {
    'title': _('RA users with bad encryption'),
    'unit': 'count',
    'color': '22/a',
}
##############################################################################
#
# map perfdata to metric
#
##############################################################################

check_metrics['check_mk-checkpoint_remoteaccess'] = {
    'dtpsConnectedUsers': {'name': 'checkpoint_remoteaccess_dtpsConnectedUsers', },
    'raUsers': {'name': 'checkpoint_remoteaccess_raUsers', },
    'raUsersActive': {'name': 'checkpoint_remoteaccess_raUsersActive', },
    'raUsersDestroy': {'name': 'checkpoint_remoteaccess_raUsersDestroy', },
    'raUsersIdle': {'name': 'checkpoint_remoteaccess_raUsersIdle', },
    'raUsersPhase1': {'name': 'checkpoint_remoteaccess_raUsersPhase1', },
    'raUsersDown': {'name': 'checkpoint_remoteaccess_raUsersDown', },
    'raUsersInit': {'name': 'checkpoint_remoteaccess_raUsersInit', },
    'raBadEncryption': {'name': 'checkpoint_remoteaccess_raBadEncryption', },
}

##############################################################################
#
# how to graph perdata
#
##############################################################################

graph_info.append({
    'title': _('Check Point Remote Access Users'),
    'metrics': [
        ('checkpoint_remoteaccess_dtpsConnectedUsers', 'line'),
        ('checkpoint_remoteaccess_raUsers', '-line'),
        ('checkpoint_remoteaccess_raUsersActive', '-stack', ),
        ('checkpoint_remoteaccess_raUsersDestroy', '-stack', ),
        ('checkpoint_remoteaccess_raUsersIdle', '-stack', ),
        ('checkpoint_remoteaccess_raUsersPhase1', '-stack', ),
        ('checkpoint_remoteaccess_raUsersDown', '-stack', ),
        ('checkpoint_remoteaccess_raUsersInit', '-stack', ),
    ],
    'scalars': [
        ('checkpoint_remoteaccess_dtpsConnectedUsers:crit', _('crit')),
        ('checkpoint_remoteaccess_dtpsConnectedUsers:warn', _('warn')),
    ],
})


graph_info.append({
    'title': _('Check Point Remote Access bad encryption'),
    'metrics': [
        ('checkpoint_remoteaccess_raBadEncryption', 'line'),
    ],
})


##############################################################################
#
# define perf-o-meter
#
##############################################################################


# perfometer_info.append(('stacked', [
#     {
#         'type': 'logarithmic',
#         'metric': 'checkpoint_connections_connections',
#         'half_value': 100000.0,
#         'exponent': 2,
#     },
#     {
#         'type': 'logarithmic',
#         'metric': 'checkpoint_connections_fwconnections',
#         'half_value': 1000.0,
#         'exponent': 2,
#     },
# ]))
